# TODO: use system six, [backports.]ssl_match_hostname
#
# Conditional build:
%bcond_without	python2	# CPython 2.x module
%bcond_without	python3	# CPython 3.x module
%bcond_without	doc	# Sphinx documentation
%bcond_with	tests	# test target (uses network etc.)

%define		module		urllib3
Summary:	HTTP library with thread-safe connection pooling, file post, and more
Summary(pl.UTF-8):	Biblioteka HTTP z bezpieczną wątkowo pulą połączeń, wysyłaniem plików itd.
Name:		python-%{module}
Version:	1.25.6
Release:	3
License:	MIT
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/simple/urllib3/
Source0:	https://files.pythonhosted.org/packages/source/u/urllib3/%{module}-%{version}.tar.gz
# Source0-md5:	a7504a9fcb7ed4ffa482fe098c80b6d4
Patch0:		%{name}-mock.patch
URL:		http://urllib3.readthedocs.org/
%if %{with python2}
BuildRequires:	python-modules >= 1:2.7
%if %{with tests}
BuildRequires:	python-PySocks >= 1.5.6
BuildRequires:	python-PySocks < 2.0
BuildRequires:	python-mock
BuildRequires:	python-nose
BuildRequires:	python-tornado
# SO_REUSEPORT option
BuildRequires:	uname(release) >= 3.9
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.4
%if %{with tests}
BuildRequires:	python3-PySocks >= 1.5.6
BuildRequires:	python3-PySocks < 2.0
BuildRequires:	python3-nose
BuildRequires:	python3-tornado
# SO_REUSEPORT option
BuildRequires:	uname(release) >= 3.9
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python-modules >= 1:2.7
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Python 2 HTTP module with connection pooling and file POST abilities.
Features are:
- Re-use the same socket connection for multiple requests (with
  optional client-side certificate verification).
- File posting (encode_multipart_formdata).
- Built-in redirection and retries (optional).
- Supports gzip and deflate decoding.
- Thread-safe and sanity-safe.

%description -l pl.UTF-8
Moduł HTTP dla Pythona 2 z pulą połączeń i możliwością wysyłania
plików metodą POST. Możliwości:
- używanie tego samego połączenia dla wielu żądań (z opcjonalną
  weryfikacją certyfikatu po stronie klienta)
- wysyłanie plików (encode_multipart_formdata)
- wbudowane przekierowania i ponawianie prób (opcjonalne)
- obsługa kodowań gzip i deflate
- bezpieczeństwo względem wątków.

%package -n python3-urllib3
Summary:	HTTP library with thread-safe connection pooling, file post, and more
Summary(pl.UTF-8):	Biblioteka HTTP z bezpieczną wątkowo pulą połączeń, wysyłaniem plików itd.
Group:		Development/Languages/Python
Requires:	python3-modules >= 1:3.4

%description -n python3-urllib3
Python 3 HTTP module with connection pooling and file POST abilities.
Features are:
- Re-use the same socket connection for multiple requests (with
  optional client-side certificate verification).
- File posting (encode_multipart_formdata).
- Built-in redirection and retries (optional).
- Supports gzip and deflate decoding.
- Thread-safe and sanity-safe.

%description -n python3-urllib3 -l pl.UTF-8
Moduł HTTP dla Pythona 3 z pulą połączeń i możliwością wysyłania
plików metodą POST. Możliwości:
- używanie tego samego połączenia dla wielu żądań (z opcjonalną
  weryfikacją certyfikatu po stronie klienta)
- wysyłanie plików (encode_multipart_formdata)
- wbudowane przekierowania i ponawianie prób (opcjonalne)
- obsługa kodowań gzip i deflate
- bezpieczeństwo względem wątków.

%package apidocs
Summary:	API documentation for Python urllib3 module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona urllib3
Group:		Documentation

%description apidocs
API documentation for Python urllib3 module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona urllib3.

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1

%build
%if %{with python2}
%py_build %{?with_tests:test}
%endif

%if %{with python3}
%py3_build %{?with_tests:test}
%endif

%if %{with doc}
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3 \
	SPHINXOPTS=
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install
%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CHANGES.rst CONTRIBUTORS.txt LICENSE.txt README.rst
%{py_sitescriptdir}/%{module}
%{py_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-urllib3
%defattr(644,root,root,755)
%doc CHANGES.rst CONTRIBUTORS.txt LICENSE.txt README.rst
%{py3_sitescriptdir}/%{module}
%{py3_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/_build/html/{_static,reference,*.html,*.js}
%endif
%changelog
* Tue Dec 03 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-urllib3.git;a=log;h=master

* Sat Nov 09 2019 Marcin Krol <hawk@tld-linux.org> 1e2cc5b
- release 3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 4ceed55
- rebuild with python 3.8
- release 2 (by relup.sh)

* Thu Oct 03 2019 Jakub Bogusz <qboosh@pld-linux.org> a957e88
- updated to 1.25.6

* Sun Dec 02 2018 Jakub Bogusz <qboosh@pld-linux.org> 70df936
- docs build requires mock module: ensure using python3, added mock patch to use unittest.mock module

* Thu Nov 08 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 3b3a1b3
- up to 1.24.1

* Sat Jul 21 2018 Jakub Bogusz <qboosh@pld-linux.org> ad572b1
- drop -W from SPHINXOPTS to avoid bailing out on no network access to download inventories
- release 2

* Sat Jul 21 2018 Jakub Bogusz <qboosh@pld-linux.org> 1cbae8f
- updated to 1.23

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2a47d28
- release 3 (by relup.sh)

* Sat Aug 05 2017 Elan Ruusamäe <glen@pld-linux.org> 5381b07
- fix python-requests

* Wed Aug 02 2017 Jacek Konieczny <j.konieczny@eggsoft.pl> 686fd12
- Version: 1.22

* Sun Mar 05 2017 Jakub Bogusz <qboosh@pld-linux.org> 9e66ed9
- updated to 1.20

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 41a3744
- python 3.6
- release 2 (by relup.sh)

* Mon Aug 22 2016 Marcin Krol <hawk@tld-linux.org> bb0777d
- updated to 1.16

* Mon Mar 28 2016 Jakub Bogusz <qboosh@pld-linux.org> fb337b2
- updated to 1.14

* Sun Nov 29 2015 Jacek Konieczny <jajcus@jajcus.net> 8cad455
- BR: rpmbuild(macros) >= 1.710

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> d42570a
- release 3 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> fbc852e
- automatic change: use py_build/py_install macros

* Mon Sep 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> ca71647
- release 2 (by relup.sh)

* Fri Mar 13 2015 Mateusz Korniak <matkor@pld-linux.org> ddcf22d
- up to 1.10.2

* Fri Mar 06 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 9855502
- up to 1.10.1

